#ifndef SCRIPTS_H
#define SCRIPTS_H

#include "buysell.h"
#include "dispatchers.h"
#include "galaxy.h"

class ScriptTerror : public Dispatch {
 private:
  MoveDispatch * md;
  std::shared_ptr<Dispatch> move;
  InputDispatch * id;
  std::shared_ptr<Dispatch> input;
  TraderDispatch * td;
  std::shared_ptr<Dispatch> trader;
  std::string old_trade_end_empty;
  
 public:
  ScriptTerror(Director &);
  ~ScriptTerror();
  int loops;
  int max_loops;
  port_pair_type ppt;
  
  void init(void);

  void activate(void) override;
  void deactivate(void) override;

  void input_notify(void);
  void move_notify(void);
  void trade_notify(void);

  void server_prompt(const std::string &prompt) override;
};

#endif